searchNodes=[{"doc":"A Split.io client for Elixir. See Glossary for explanations about function arguments and return values","ref":"SplitClient.html","title":"SplitClient","type":"module"},{"doc":"Get all the treatments for one or more traffic types. Args keys - A list of maps containing the following: :matching_key :traffic_type :bucketing_key - Optional Options :attributes Examples iex&gt; SplitClient . get_all_treatments ( %{ matching_key : &quot;unique-customer-id&quot; , target_type : &quot;customer&quot; } , %{ matching_key : &quot;unique-user-id&quot; , target_type : &quot;user&quot; } ) %{ &quot;customer&quot; =&gt; %{ &quot;shiny-feature&quot; =&gt; % Treatment { treatment : &quot;on&quot; } } , &quot;user&quot; =&gt; %{ &quot;my-experiment&quot; =&gt; % Treatment { treatment : &quot;off&quot; } } }","ref":"SplitClient.html#get_all_treatments/2","title":"SplitClient.get_all_treatments/2","type":"function"},{"doc":"Get the treatment for a specific split. Args key split_name Options :attributes :bucketing_key Examples iex&gt; SplitClient . get_treatment ( &quot;unique-customer-id&quot; , &quot;shiny-feature&quot; ) % Treatment { split_name : &quot;shiny-feature&quot; , treatment : &quot;on&quot; }","ref":"SplitClient.html#get_treatment/3","title":"SplitClient.get_treatment/3","type":"function"},{"doc":"Get the treatments for multiple splits. Args key split_name Options :attributes :bucketing_key Examples iex&gt; SplitClient . get_treatments ( &quot;unique-customer-id&quot; , [ &quot;shiny-feature&quot; , &quot;my-experiment&quot; ] ) %{ &quot;shiny-feature&quot; =&gt; % Treatment { treatment : &quot;on&quot; } , &quot;my-experiment&quot; =&gt; % Treatment { split_name : &quot;my-experiment&quot; , treatment : &quot;off&quot; } }","ref":"SplitClient.html#get_treatments/3","title":"SplitClient.get_treatments/3","type":"function"},{"doc":"Determine if a particular split is turned off. This is syntax sugar around the get_treatment/3 function. If your treatment has a meaningful config that could be returned then use get_treatment/3 instead Args key split_name Options :attributes :bucketing_key Examples iex&gt; SplitClient . off? ( &quot;unique-customer-id&quot; , &quot;shiny-feature&quot; ) true","ref":"SplitClient.html#off?/3","title":"SplitClient.off?/3","type":"function"},{"doc":"Determine if a particular split is turned on. This is syntax sugar around the get_treatment/3 function. If your treatment has a meaningful config that could be returned then use get_treatment/3 instead Args key split_name Options :attributes :bucketing_key Examples iex&gt; SplitClient . on? ( &quot;unique-customer-id&quot; , &quot;shiny-feature&quot; ) true","ref":"SplitClient.html#on?/3","title":"SplitClient.on?/3","type":"function"},{"doc":"A DataSource intended for local development. Will consume a YAML file that developers can use to test feature flags without having to modify global data on the Split.IO web portal See also: Local Feature Development","ref":"SplitClient.DataSourceYAML.html","title":"SplitClient.DataSourceYAML","type":"module"},{"doc":"Handles the orchestration of keeping treatment data isolated between concurrently running tests. It assumes that the SplitClient calls from your Application code are running in the same process as the test. If they are not, you will have to explicitally allow some other child process to access the treatments data or make the test async: false","ref":"SplitClient.Sandbox.html","title":"SplitClient.Sandbox","type":"module"},{"doc":"Associate a process that is making SplitClient calls with a specific test's isolated Treatment data Examples iex&gt; SplitClient.Sandbox . allow ( self ( ) , Process . whereis ( :foo ) ) :ok","ref":"SplitClient.Sandbox.html#allow/3","title":"SplitClient.Sandbox.allow/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"SplitClient.Sandbox.html#child_spec/1","title":"SplitClient.Sandbox.child_spec/1","type":"function"},{"doc":"Populate the test environment with split information that your application code depends on. Your splits should come as a list of maps. Each map should have one key for the split_name which has as its value a map with the treatment information. create_splits/1 must be run after SplitClient.Testing.setup_split_client/1 [ %{ &quot;my_feature&quot; =&gt; %{ treatment : &quot;on&quot; , keys : &quot;mock_user_id&quot; , traffic_type : &quot;customer&quot; } } , %{ &quot;my_feature&quot; =&gt; %{ treatment : &quot;off&quot; , traffic_type : &quot;customer&quot; } } ]","ref":"SplitClient.Sandbox.html#create_splits/1","title":"SplitClient.Sandbox.create_splits/1","type":"function"},{"doc":"","ref":"SplitClient.Sandbox.html#get_all_treatments/2","title":"SplitClient.Sandbox.get_all_treatments/2","type":"function"},{"doc":"","ref":"SplitClient.Sandbox.html#get_treatment/3","title":"SplitClient.Sandbox.get_treatment/3","type":"function"},{"doc":"","ref":"SplitClient.Sandbox.html#get_treatments/3","title":"SplitClient.Sandbox.get_treatments/3","type":"function"},{"doc":"Change how treatment data is looked up based on whether the test is async: false or async: true","ref":"SplitClient.Sandbox.html#set_async_mode/2","title":"SplitClient.Sandbox.set_async_mode/2","type":"function"},{"doc":"Associate a test process with a new data source server that will be isolated from all other tests","ref":"SplitClient.Sandbox.html#setup_test_treatments/3","title":"SplitClient.Sandbox.setup_test_treatments/3","type":"function"},{"doc":"","ref":"SplitClient.Sandbox.html#start_link/1","title":"SplitClient.Sandbox.start_link/1","type":"function"},{"doc":"Teardown logic when a test is done","ref":"SplitClient.Sandbox.html#teardown_test_treatments/2","title":"SplitClient.Sandbox.teardown_test_treatments/2","type":"function"},{"doc":"Functions to help with feature flag testing as well as making the concurrently running tests isolated and predictable","ref":"SplitClient.Testing.html","title":"SplitClient.Testing","type":"module"},{"doc":"See SplitClient.Sandbox.create_splits/1 .","ref":"SplitClient.Testing.html#create_splits/1","title":"SplitClient.Testing.create_splits/1","type":"function"},{"doc":"Add setup :setup_split_client to the top of your test file. This will ensure that your Split.io treatments are isolated to your test and not inteferring with other tests running in parallel","ref":"SplitClient.Testing.html#setup_split_client/1","title":"SplitClient.Testing.setup_split_client/1","type":"function"},{"doc":"A structured way to represent Split.io treatment data. This respresents the treatment the user should receive based on the parameters given to Split.io Fields split_name - The name of the Split the treatment applies to. Split names are unique even if they are associated with a different traffic type treatment - Which treatment to apply (e.g. &quot;on&quot;/&quot;off&quot;) config - Optional. Extra configuration that applies to the treatment (e.g. %{color: &quot;blue&quot;} )","ref":"SplitClient.Treatment.html","title":"SplitClient.Treatment","type":"module"},{"doc":"","ref":"SplitClient.Treatment.html#new/1","title":"SplitClient.Treatment.new/1","type":"function"},{"doc":"","ref":"SplitClient.Treatment.html#t:t/0","title":"SplitClient.Treatment.t/0","type":"type"},{"doc":"Elixir client to use for Split.io feature flag service https://www.split.io/","ref":"readme.html","title":"SplitClient","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding split_client to your list of dependencies in mix.exs : def deps do [ { :split_client , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"SplitClient - Installation","type":"extras"},{"doc":"Evaluator Configuration The Split.io Evaluator sits in your infrastructure between the Split.io servers. It provides a REST API for accessing Split.io data and is meant to be used in cases where Split.io has not created an SDK for a specific language like Elixir. In order for your application to access Split.io feature flag data you'll need to configure how to access your instance of Split.io Evaluator . You'll need to configure the evaluator_auth_token and the evaluator_url . In production you'll need to have your config access these environment variables. You could do it like this in config/prod.exs : config :split_client , evaluator_auth_token : System . fetch_env! ( &quot;SPLIT_EVALUATOR_AUTH_TOKEN&quot; ) config :split_client , evaluator_url : System . fetch_env! ( &quot;SPLIT_EVALUATOR_URL&quot; ) Local Feature Development When you're developing features locally you don't want to toggle split treatments in the Split.io web interface. The web interface changes things globally across your infrastructure and isn't meant for testing changes on your local machine. Instead you'll make changes in a local YAML file. Add this to your config/dev.exs config :split_client , data_source : SplitClient.DataSourceYAML By default the SplitClient will expect this YAML file to live in the root of your project and be called split.yml . You can change this in config/dev.exs with config :split_client , split_file : &quot;my/file/path.yml&quot; The YAML file should follow a format similar to this: # - feature_name: # treatment: &quot;treatment_applied_to_this_entry&quot; # keys: [&quot;single_key_or_list&quot;, &quot;other_key_same_treatment&quot;] # traffic_type: &quot;customer&quot; # config: &quot;{\\&quot;desc\\&quot; : \\&quot;this applies only to ON treatment\\&quot;}&quot; # # Note that the &quot;treatment&quot; and &quot;traffic_type&quot; keys are mandatory, but both &quot;keys&quot; and # &quot;config&quot; are optional. If &quot;keys&quot; are omitted they will be a fallback for when a passed key # doesn't match # Note that the config is JSON # Note that `keys` can be a single key or a list of keys # Not the attributes and bucketing_keys are ignored when using YAML stub - my_feature: treatment: &quot;on&quot; keys: &quot;mock_user_id&quot; traffic_type: &quot;customer&quot; config: &quot;{\\&quot;desc\\&quot; : \\&quot;this applies only to ON treatment\\&quot;}&quot; - some_other_feature: treatment: &quot;off&quot; traffic_type: &quot;customer&quot; - my_feature: treatment: &quot;off&quot; traffic_type: &quot;customer&quot; Caching and Treatment Updates Out of the box the SplitClient will automatically cache treatments with a 1 minute expiration. You can change this by setting the :cache_ttl to a number of milliseconds of your choosing config :split_client , :cache_ttl , :timer . seconds ( 1 ) Test Configuration Normally you want your application to share a global cache of Split.io data. This isn't the case when you are running tests. In the testing environment you want each test to have its own isolated set of Split data so that each test can be run concurrently. To ensure this you can swap out the regular Treatments server for a Sandbox in config/test.exs config :split_client , :treatments_server , SplitClient.Sandbox","ref":"readme.html#configuration","title":"SplitClient - Configuration","type":"extras"},{"doc":"In Split.io nomenclature a &quot;Split&quot; is equivalent to a &quot;Feature Flag&quot; Function Arguments key or matching_key - Some kind of unique identifier to identify the user, customer, account, etc. A non-match results in default/control treatment split_name - The name of the Split to get the treatment for (e.g. &quot;shiny_feature&quot; ) traffic_type - The Split.io Traffic Type the splits are associated with (e.g. &quot;user&quot; , &quot;customer&quot; , &quot;account&quot; , etc) Function Options :attributes - A Map of custom attributes to target on (e.g. %{plan_type: &quot;premium&quot;, paying_customer: true} ) See also: Target Customer Attributes :bucketing_key - Which part of the distribution to look for a treatment out of 100% (e.g. &quot;20-39&quot; ) See also: Treatment Order","ref":"readme.html#split-io-glossary","title":"SplitClient - Split.io Glossary","type":"extras"},{"doc":"Normally you want your application to share a global cache of Split.io data. This isn't the case when you are running tests. In the testing environment you want each test to have its own isolated set of Split data so that each test can be run concurrently. A little bit of setup in each test file will be required. import SplitClient.Testing setup :setup_split_client First, you'll want to import the SplitClient.Testing module and execute setup_split_client/1 before every test. This will give each test it's own Split environment that won't be affected by any other tests running in parallel. Second, you'll want to create your Split definitions. This can be the same for all tests in the file or vary per test. These definitions follow the same rules as the ones in Local Feature Development setup do create_splits ( [ %{ &quot;my_feature&quot; =&gt; %{ treatment : &quot;on&quot; , keys : &quot;mock_user_id&quot; , traffic_type : &quot;customer&quot; } } , %{ &quot;my_feature&quot; =&gt; %{ treatment : &quot;off&quot; , traffic_type : &quot;customer&quot; } } ] ) :ok end create_splits/1 takes list of maps. Each map should have one key for the split_name which has as its value a map with the treatment information. Multi-process Collaboration Explicit Allowance You may have a process in your application that is using Split.io data that is outside of the test process. In this case you'll need to explicitally associate the test process with the outside process so that the isolated Split data can be accessed. You can use SplitClient.Sandbox.allow/2 for this. test &quot;test a thing&quot; do task = Task . async ( fn -&gt; assert feature_a ( &quot;mock_user_id&quot; ) == &quot;New Hotness&quot; end ) Sandbox . allow ( self ( ) , task . pid ) Task . await ( task ) end Async False Sometimes there are unfortunate circumstances where you do not own the process accessing your Split.io data or the process is otherwise unnamed and unaccessible. In these circumstances you'll be relegated to making your test async: false to ensure that the test is predictable and only accesses Split data that it's supposed to","ref":"readme.html#testing","title":"SplitClient - Testing","type":"extras"},{"doc":"If you are making improvements to this package there will be some setup involved. Accessing a Split.io Evaluator Instance You'll need to add environment variables of SPLIT_EVALUATOR_AUTH_TOKEN and SPLIT_EVALUATOR_URL if you would like to test against a real Evaluator instance. You'll also need to make the Evaluator your datasource in the dev environment. Update to config/dev.exs to include: config :split_client , :data_source , SplitClient.Boundary.Evaluator Documentation Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/split_client .","ref":"readme.html#contributing","title":"SplitClient - Contributing","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Swaps out the custom cache for Cachex because of timeouts happening in SplitClient.Boundary.Treatments calls. The cache had a complicated api key consisting of key, split_name, and any attributes. This was likely overkill, made the cache too big, and made lookups too expensive which likely caused the timeouts. After 10,000 or so get_treatment calls with unique keys the server would timeout. Now we can run 100,000 get_treatments calls with with unique keys and see no timeouts. There's no more polling the split_evaluator, instead developers can configure a :cache_ttl","ref":"changelog.html#0-2-0","title":"Changelog - 0.2.0","type":"extras"}]